stages:
  - build
  - deploy
variables:
  IMAGE_NAME: "hamzarehmanshaikh/todayproject"
  IMAGE_TAG: "2.0"
  DEV_SERVER_IP: 16.171.25.204

build-image:
  stage: build
  image: docker:20.10.10
  services:
    - docker:20.10.10-dind

  script:
    - echo "Building docker image"

  before_script:
    - docker login -u $CI_DOCKER_USER -p $CI_DOCKER_PASSWORD
    - docker build -t $IMAGE_NAME:$IMAGE_TAG .
    - docker images
    - docker push $IMAGE_NAME:$IMAGE_TAG
deploy-on-aws:
  stage: deploy
  image: docker:20.10.10
  services:
    - docker:20.10.10-dind
  before_script:
    - chmod 400 $SSH_PRIVATE_KEY
  script:
    - echo "Deploying in AWS..."
    - ssh -o StrictHostKeyChecking=no -i $SSH_PRIVATE_KEY ubuntu@$DEV_SERVER_IP "
        docker run -d -p 3000:80 --name todayproject $IMAGE_NAME:$IMAGE_TAG"
